#pragma semicolon 1
#pragma newdecls required

#include <sdktools_stringtables>
#include <sdktools_tempents>
#include <sdktools_tempents_stocks>
#include <shop>

bool
	bEnable,
	bEnableInvis,
	g_bHasLJ[MAXPLAYERS+1];
	
int
	iBeam,
	iHalo;
	
float
	fStart,		// Начало
	fEnd,		// Окончание
	fLife,	// Время жизни
	fWidth,		// Ширина луча
	fAmplitude[3],	// Амплитуда
	fPos2;

#define CATEGORY	"ability"
#define ITEM		"jump_effect"

Handle g_hPrice,
	g_hDuration;
ItemId id;

char Engine_Version;

#define GAME_UNDEFINED 0
#define GAME_CSS_34 1
#define GAME_CSS 2
#define GAME_CSGO 3

int GetCSGame()
{
	if (GetFeatureStatus(FeatureType_Native, "GetEngineVersion") == FeatureStatus_Available) 
	{ 
		switch (GetEngineVersion()) 
		{ 
			case Engine_SourceSDK2006: return GAME_CSS_34; 
			case Engine_CSS: return GAME_CSS; 
			case Engine_CSGO: return GAME_CSGO; 
		} 
	} 
	return GAME_UNDEFINED;
}

public APLRes AskPluginLoad2()
{
	Engine_Version = GetCSGame();
	if(Engine_Version == GAME_UNDEFINED)
		SetFailState("Game is not supported!");
		
	return APLRes_Success;
}

public Plugin myinfo =
{
	name		= "[Shop/Any] Jump effect/Эффект от прыжка",
	version		= "1.3.2 (rewritten by Grey83)",
	description	= "Волны от прыжков",
	author		= "Nek.'a 2x2 | ggwp.site",
	url			= "https://ggwp.site/"
}

public void OnPluginStart()
{
	ConVar cvar;
	cvar = CreateConVar("sm_shop_jumpeffect_shop_enable", "1", "Включить/выключить эффект волн при прыжке.", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Enable);
	bEnable = cvar.BoolValue;
	
	cvar = CreateConVar("sm_shop_jumpeffect_invise", "1", "1 Включить только для своей команды, 0 отображение для всех", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_EnableInvis);
	bEnableInvis = cvar.BoolValue;
	
	//Начало
	cvar = CreateConVar("sm_shop_jumpeffect_stpos", "1.0", "начальное кольцо", _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Start);
	fStart = cvar.FloatValue;
	
	//Окончание
	cvar = CreateConVar("sm_shop_jumpeffect_undpos", "140.0", "Окончание кольца", _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_End);
	fEnd = cvar.FloatValue;
	
	//Время жизни
	cvar = CreateConVar("sm_shop_jumpeffect_timelife", "1.5", "Время жизни эффекта", _, true, 0.1);
	cvar.AddChangeHook(CVarChanged_Life);
	fLife = cvar.FloatValue;
	
	//Ширина луча
	cvar = CreateConVar("sm_shop_jumpeffect_width", "20.0", "Ширина луча", _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Width);
	fWidth = cvar.FloatValue;
	
	//Амплитуда
	cvar = CreateConVar("sm_shop_jumpeffect_amplitude1", "10.0", "Амплитуда 1-й волны", _, true);
	cvar.AddChangeHook(CVarChanged_Amplitude1);
	fAmplitude[0] = cvar.FloatValue;
	
	cvar = CreateConVar("sm_shop_jumpeffect_amplitude2", "50.0", "Амплитуда 2-й волны", _, true);
	cvar.AddChangeHook(CVarChanged_Amplitude2);
	fAmplitude[1] = cvar.FloatValue;
	
	cvar = CreateConVar("sm_shop_jumpeffect_amplitude3", "20.0", "Амплитуда 3-й волны");
	cvar.AddChangeHook(CVarChanged_Amplitude3);
	fAmplitude[2] = cvar.FloatValue;
	
	cvar = CreateConVar("sm_shop_jumpeffect_pos2", "10", "Высота эффекта");
	cvar.AddChangeHook(CVarChanged_Pos2);
	fPos2 = cvar.FloatValue;

	HookEvent("player_jump", Event_Jump);

	//Shop Core
	g_hPrice = CreateConVar("sm_shop_jumpeffect_price", "1000", "Стоимость jump_effect.");
	HookConVarChange(g_hPrice, OnConVarChange);
	
	g_hDuration = CreateConVar("sm_shop_jumpeffect_duration", "86400", "Длительность в секундах jump_effect.");
	HookConVarChange(g_hDuration, OnConVarChange);

	AutoExecConfig(true, "jump_effect", "shop");
	
	if (Shop_IsStarted()) Shop_Started();
}

public void OnConVarChange(Handle hCvar, const char[] oldValue, const char[] newValue)
{
	if(id != INVALID_ITEM)
	{
		if(hCvar == g_hPrice) Shop_SetItemPrice(id, GetConVarInt(hCvar));
		else if(hCvar == g_hDuration) Shop_SetItemValue(id, GetConVarInt(hCvar));
	}
}

public void OnPluginEnd()
{
	Shop_UnregisterMe();
}

public void Shop_Started()
{
	CategoryId category_id = Shop_RegisterCategory(CATEGORY, "Способности", "");
	
	if (Shop_StartItem(category_id, ITEM))
	{
		Shop_SetInfo("Волны при прыжке", "", GetConVarInt(g_hPrice), -1, Item_Togglable, GetConVarInt(g_hDuration));
		Shop_SetCallbacks(OnItemRegistered, OnLJUsed);
		Shop_EndItem();
	}
}

public void OnItemRegistered(CategoryId category_id, const char[] category, const char[] item, ItemId item_id)
{
	id = item_id;
}

public void OnClientPostAdminCheck(int iClient)
{
	g_bHasLJ[iClient] = false;
}

public ShopAction OnLJUsed(int iClient, CategoryId category_id, const char[] category, ItemId item_id, const char[] item, bool isOn, bool elapsed)
{
	if(isOn || elapsed)
	{
		g_bHasLJ[iClient] = false;
		return Shop_UseOff;
	}
	g_bHasLJ[iClient] = true;
	return Shop_UseOn;
}

public void CVarChanged_Enable(ConVar CVar, const char[] oldValue, const char[] newValue)
{
	bEnable = CVar.BoolValue;
}

public void CVarChanged_EnableInvis(ConVar CVar, const char[] oldValue, const char[] newValue)
{
	bEnableInvis = CVar.BoolValue;
}

public void CVarChanged_Start(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fStart = cvar.FloatValue;
}

public void CVarChanged_End(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fEnd = cvar.FloatValue;
}

public void CVarChanged_Life(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fLife = cvar.FloatValue;
}

public void CVarChanged_Width(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fWidth = cvar.FloatValue;
}

public void CVarChanged_Amplitude1(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fAmplitude[0] = cvar.FloatValue;
}

public void CVarChanged_Amplitude2(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fAmplitude[1] = cvar.FloatValue;
}

public void CVarChanged_Amplitude3(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fAmplitude[2] = cvar.FloatValue;
}

public void CVarChanged_Pos2(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	fPos2 = cvar.FloatValue;
}

public void OnMapStart()
{
	if(Engine_Version == GAME_CSS)
	{
		iBeam = PrecacheModel("sprites/laser.vmt");
		iHalo = PrecacheModel("sprites/halo.vmt");
	}
	if(Engine_Version == GAME_CSS_34)
	{
		iBeam = PrecacheModel("sprites/laser.vmt");
		iHalo = PrecacheModel("sprites/halo01.vmt");		
	}
	if(Engine_Version == GAME_CSGO)
	{
		iBeam = PrecacheModel("sprites/laserbeam.vmt");
		iHalo = PrecacheModel("sprites/halo.vmt");
	}
}

public void Event_Jump(Event event, const char[] name, bool dontBroadcast)
{	
	if(!bEnable || !iBeam || !iHalo)
		return;

	static int client;
	if(!(client = GetClientOfUserId(GetEventInt(event, "userid"))) || !IsClientInGame(client))
		return;

	static int t, i, clients[MAXPLAYERS], num;
	t = GetClientTeam(client);
	for(i = 1, num = 0; i <= MaxClients; i++)
		if(IsClientInGame(i) && !IsFakeClient(i) && (!bEnableInvis || GetClientTeam(i) == t))
			clients[num++] = i;
	if(!num) return;

	if(g_bHasLJ[client])
	{
		static int ver, clr[4] = {0, 0, 0, 255};
		static float pos[3];
		ver = GetRandomInt(0, 2);
		GetClientAbsOrigin(client, pos);
		pos[2] += fPos2;

		switch(ver)
		{
			case 0:
			{
				if(t == 2)
				{
					clr[0] = GetRandomInt(1, 100);
					clr[1] = GetRandomInt(1, 100);
					clr[2] = GetRandomInt(1, 200);
				}
				else
				{
					clr[0] = GetRandomInt(1, 50);
					clr[1] = GetRandomInt(1, 50);
					clr[2] = GetRandomInt(1, 100);
				}
			}
			case 1:
			{
				if(t == 2)
				{
					clr[0] = GetRandomInt(1, 255);
					clr[1] = clr[2] = 1;
				}
				else
				{
					clr[0] = clr[1] = 1;
					clr[2] = GetRandomInt(1, 255);
				}
			}
			case 2:
			{
				clr[0] = GetRandomInt(1, 255);
				clr[1] = GetRandomInt(1, 255);
				clr[2] = GetRandomInt(1, 255);
			}
		}
		TE_SetupBeamRingPoint(pos, fStart, fEnd, iBeam, iHalo, 0, 0, fLife, fWidth, fAmplitude[ver], clr, 50, 0);
		TE_Send(clients, num);
	}
}